'use strict';

module.exports = function(name, options) {
  var engine = options.engines[name] || options.engines[aliases(name)];
  if (typeof engine === 'undefined') {
    throw new Error(`gray-matter engine "${name}" is not registered`);
  }
  if (typeof engine === 'function') {
    engine = { parse: engine };
  }
  return engine;
};

function aliases(name) {
  switch (name.toLowerCase()) {
    case 'js':
    case 'javascript':
      return 'javascript';
    case 'coffee':
    case 'coffeescript':
    case 'cson':
      return 'coffee';
    case 'yaml':
    case 'yml':
      return 'yaml';
    default: {
      return name;
    }
  }
}
